#include <stdlib.h>
#include <stdio.h>

struct Allocator{
  unsigned char *memory;
  int obj_size;
  int position;
  int mem_size;
};


struct Allocator *create_allocator(int nobjects,int objsize){
  struct Allocator *a=malloc(sizeof(*a));
  a->memory = malloc(objsize * nobjects);
  a->obj_size=nobjects;
  a->position=0;
  a->mem_size=nobjects;
  return a;
}

void free_allocator(struct Allocator *a){
  free(a->memory);
  free(a);
}


void *get_object(struct Allocator *a){
  void *p;
  if (a->position >= a->mem_size){
    return NULL;
  }
  p=a->memory + a->position * a->obj_size;
  a->position+=1;
  return p;
}

struct Matrix{
  int data[4][4];
};

void matrix_print(struct Matrix *m){
  int i,j;
  for(i=0;i<4;++i){
    for(j=0;j<4;++j)
      printf("%d ",m->data[i][j]);
    printf("\n");
  }
}

void matrix_set(struct Matrix *m, int v){
  int i,j;
  for(i=0;i<4;++i)
    for(j=0;j<4;++j)
      m->data[i][j]=v;
}


int main(){
  int i,j;
  struct Allocator *alloc=create_allocator(2,sizeof(struct Matrix));
  struct Matrix *m1 = get_object(alloc);
  struct Matrix *m2 = get_object(alloc);
  matrix_set(m1,5);
  matrix_set(m2,8);
  matrix_print(m1);
  matrix_print(m2);
  free_allocator(alloc);
}
