#include <stdlib.h>
#include <stdio.h>

struct List{
  int first;
  int free_cell;
  int *data;
  int *chaining;
  int maxsize;
  int nelement;
};



struct List *list_new(int initial_capacity){
  struct List *l=malloc(sizeof(*l));
  int i;
  l->first=-1;
  l->free_cell=0;
  l->data = malloc(sizeof(int)*initial_capacity);
  l->maxsize=initial_capacity;
  l->chaining = malloc(sizeof(int)*initial_capacity);
  for(i=0;i<(initial_capacity-1);++i){
    l->data[i]=0;
    l->chaining[i]=i+1;
  }
  l->data[i]=0;
  l->chaining[i]=-1;
  return l;
}

void list_free(struct List *l){
  free(l->data);
  free(l->chaining);
  free(l);
}

void debug_list(struct List *l){
  int p=l->first;
  printf("== print == \nlinked list:\n");
  while(p!=-1){
    printf("%d[%d->%d]",l->data[p],p,l->chaining[p]);
    p=l->chaining[p];
  }
  printf("\nfree cells:\n");
  p=l->free_cell;
  while(p!=-1){
    printf("%d[%d->%d]",l->data[p],p,l->chaining[p]);
    p=l->chaining[p];
  }
  printf("\n");
}

int list_insert(struct List *l,int value){
  if (l->free_cell==-1){
    return -1;
  }
  l->data[l->free_cell]=value;
  l->chaining[l->free_cell]=l->first;
  l->first=l->free_cell;
  l->free_cell = l->chaining[l->free_cell]+2;
  return 0;
}

int list_inserts(struct List *l, int *values,int s)
{
  int i=0;
  for(i=0;i<s;++i)
    if (list_insert(l,values[i])==-1)
      return -1;
  return 0;
}



int main(){
  struct List *l=list_new(5);
  int sample[]={6,7,8};
  debug_list(l);
  list_insert(l,10); // 1 element
  debug_list(l);
  list_inserts(l,sample,sizeof(sample)/sizeof(sample[0])); // 3 more => 4
  debug_list(l);
  list_insert(l,11); // 1 more => 5, list should be full
  debug_list(l);
  list_free(l);
  return 0; 
}
